#include <windows.h>
#include <stdio.h>

void new_diskim(char *disk, unsigned int size) 
{
FILE *fpdisk;
unsigned char byte;
long i;

	size &= 0xfff;		// size = 800 for 80 track, single sided

	fpdisk = fopen(disk, "wb");
	byte = 0;

	for (i = 0; i < 512; i++)
		fwrite(&byte, 1, 1, fpdisk);

	byte = (size >> 8);
	fseek(fpdisk, 256 + 6L, SEEK_SET);
	byte |= 3 << 4;
	fwrite(&byte, 1, 1, fpdisk);  /*i.e. bootoption=*EXEC, sect on disk='size' */
	byte=(size & 0xff);
	fwrite(&byte, 1, 1, fpdisk);

	fclose(fpdisk);
}

void add_bbc_file(  char *bbcfilename, 
					char *filename,
					unsigned long loadaddress,
					unsigned long execaddress,
					unsigned long filelength,
					char *fn)

{
FILE *fpdisk, *fpadd;
unsigned char byte,H;
char bbcfile_name[15];
unsigned char afiles=0;
int  i;
unsigned long startsector, length;
unsigned char eellddss, locked;
unsigned int sectorsondisk;
unsigned long j;
unsigned char buff[8];
bool found;
bool again;


top : ;

	fpdisk = fopen(bbcfilename, "rb");
	if (fpdisk == NULL)
	{
		new_diskim(bbcfilename, 800);
	}
	else
	{
		fclose(fpdisk);
	}

	fpadd = fopen(fn,"rb");

	if (fpadd == NULL)
	{
		printf("Can't find file %s\n", fn);
		return;
	}

	fpdisk = fopen(bbcfilename,"rb+");

	if (fpdisk == NULL)
	{
		printf("Can't find file %s\n", bbcfilename);
		return;
	}

	/* number of catalog entries (afiles = 8 * number of entries): */
	fseek(fpdisk, 256 + 5L, SEEK_SET);
	fread(&afiles, 1, 1, fpdisk);

	if (afiles == 31*8)
	{
		fclose(fpadd);
		fclose(fpdisk);
		printf("There are already 31 files on the diskimage\n");
		bbcfilename[0]++;
		printf("Creating a new disk image called %s\n", bbcfilename);
		goto top;
    }

	locked=0;

	strcpy(bbcfile_name, filename);

	bbcfile_name[9]=0;

    /* Should check that second char is '.' else use $.name */
    if (bbcfile_name[1]!='.') 
	{
		for (i=9; i>=0; i--) bbcfile_name[i+2]=bbcfile_name[i];
		bbcfile_name[0]='$'; bbcfile_name[1]='.';
    }
    bbcfile_name[9]=0;

	/* Check if filename already exists. If so, put in a new directory */

	again = true;

	while (again == true)
	{

		again = false;

		for (i = 0; i < afiles / 8; ++i)
		{
			fseek(fpdisk, i * 8 + 8, SEEK_SET);
			fread(buff, 1, 8, fpdisk);

			found = true;

			for (j = 0; j < 7; ++j)
			{
				byte = bbcfile_name[j + 2];
				if (byte == 0)
				{
					byte = ' ';
					bbcfile_name[j + 3] = 0;
				}
				if (byte != (buff[j] & 127))
				{
					found = false;
					j = 8;
				}
			}

			if (found == true)		// If found and directories match, inc directory
			{
				if (bbcfile_name[0] == (buff[7] & 127))
				{
					if (bbcfile_name[0] == '$')
					{
						bbcfile_name[0] = 'A';
					}
					else
					{
						bbcfile_name[0]++;
					}
					i = 32;
					again = true;
				}
			}
		}
	}

	/* GET PREVIOUS STARTSECTOR AND FILE LENGTH */
    if (afiles) 
	{
		fseek(fpdisk, 256L + 14L, SEEK_SET);

		fread(&eellddss, 1, 1, fpdisk);
		/* STARTSECTOR */
		fread(&byte, 1, 1, fpdisk);
		startsector = byte + (long) (eellddss & 0x3) * 256L;

		/* FILELENGTH */
		fseek(fpdisk, 256L + 12L, SEEK_SET);
		fread(&byte, 1, 1, fpdisk);
		fread(&H, 1, 1, fpdisk);
		length = H * 256L + byte + (eellddss & 0x30) * 16L * 256L;

		startsector +=(length + 255) >> 8;
    }
    else startsector = 2;


    /* Check for enough sectors left on disc */
	fseek(fpdisk, 256 + 6L, SEEK_SET);
	fread(&byte, 1, 1, fpdisk);
	H = byte & 3;
	fread(&byte, 1, 1, fpdisk);
	sectorsondisk = byte + H * 256L;

    if (startsector + ((filelength + 255)>>8)> sectorsondisk) 
	{
		fclose(fpadd);
		fclose(fpdisk);
		printf("Not enough space on the diskimage\n");
		bbcfilename[0]++;
		printf("Creating a new disk image called %s\n", bbcfilename);
		goto top;
		
	}

	printf("adding file %s\n", bbcfile_name);


/* COPY FILE: */

	for(j = 0; j < (((filelength + 255) >>8) * 256L); j++) 
	{
		fseek(fpadd, j, SEEK_SET);
		if (!fread(&byte, 1, 1, fpadd)) byte=0;
		fseek(fpdisk, startsector * 256L + j, SEEK_SET);
		fwrite(&byte, 1, 1, fpdisk);
	}

	fclose(fpadd);

    /* ADD FILENAME TO CATALOGUE */

    for (j = 255 - 8; j > 7; j--) 
	{
		fseek(fpdisk, j, SEEK_SET);
		fread(&byte, 1, 1, fpdisk);
		fseek(fpdisk, j + 8, SEEK_SET);
		fwrite(&byte, 1, 1, fpdisk);
		fseek(fpdisk, j + 256L, SEEK_SET);
		fread(&byte, 1, 1, fpdisk);
		fseek(fpdisk, j + 8 + 256L, SEEK_SET);
		fwrite(&byte, 1, 1, fpdisk);
	}

	byte = bbcfile_name[0] + (locked << 7);
	fseek(fpdisk, 15L, SEEK_SET);
	fwrite(&byte, 1, 1, fpdisk);
    
	fseek(fpdisk, 8L, SEEK_SET);
	for(i = 0; i < 7; i++) 
	{
		byte = bbcfile_name[i + 2];
		if (byte == 0)
		{
			byte = ' ';
			bbcfile_name[i + 3] = 0;
		}
		fwrite(&byte, 1, 1, fpdisk);
	}

    afiles += 8;
	fseek(fpdisk, 256 + 5L, SEEK_SET);
	fwrite(&afiles, 1, 1, fpdisk);


    /* write load/exec adresses + file length */
	fseek(fpdisk, 256L + 14L, SEEK_SET);
	eellddss = (unsigned char) (((startsector >> 8) & 0x3) + ((loadaddress >>14) &0xC));
	eellddss += (unsigned char) (((execaddress >> 10) &0xC0));
	eellddss += (unsigned char) (((filelength >>12) &0x30));
	fwrite(&eellddss, 1, 1, fpdisk);

	/* STARTSECTOR */
	byte = (unsigned char) (startsector & 0xff);
	fwrite(&byte, 1, 1, fpdisk);

	/* LOADADDRESS */
	fseek(fpdisk, 256L + 8L, 0);
	byte = (unsigned char) (loadaddress & 0xff);
	H = (unsigned char) ((loadaddress >>8) & 0xff);
	fwrite(&byte, 1, 1, fpdisk);
	fwrite(&H, 1, 1,fpdisk);

	/* EXECADDRESS */
	byte = (unsigned char) (execaddress & 0xff);
	H = (unsigned char) ((execaddress >>8) & 0xff);
	fwrite(&byte, 1, 1,fpdisk);
	fwrite(&H, 1, 1, fpdisk);

	/* FILELENGTH */
	byte = (unsigned char) (filelength & 0xff);
	H = (unsigned char) ((filelength >> 8) & 0xff);
	fwrite(&byte, 1, 1, fpdisk);
	fwrite(&H, 1, 1, fpdisk);

	fclose(fpdisk);
}
